#if !defined (MOUSE_DEF)
#define MOUSE_DEF

#if defined (MOUSE_GLOBAL)
#define MOUSE_EXTERN
#else
#define MOUSE_EXTERN  extern
#endif

#include "window.h"
#undef PROTO_DEF
#include "proto.h"
#define NOMOUSE   -1
#define MOUSEFOUND 0

#define MOUSELEFT_PRESS            500
#define MOUSERIGHT_PRESS           501
#define MOUSEMIDDLE_PRESS          502
#define MOUSELEFTRIGHT_PRESS       503
#define MOUSEMIDDLERIGHT_PRESS     504
#define MOUSEMIDDLELEFT_PRESS      505
#define MOUSEMIDDLERIGHTLEFT_PRESS 506

#define MOUSEPRESSED               1
#define KEYBOARDPRESSED            0

#define MOUSE_FULL_INSTALL 1
#define MOUSE_TEST         2
#define GET_MPRESS_KEY(a)                get_mouse_or_key(0,a)
#define GET_MPRESS_ENHANCED_KEY(a)       get_mouse_or_key(1,a)

MOUSE_EXTERN char *mouse_state_buffer;
MOUSE_EXTERN char mouse_state_saved;

#ifdef __cplusplus
#define UNKNOWNARGS ...
#else
#define UNKNOWNARGS
#endif


#ifdef __cplusplus
extern "C"
{
#endif


int       MouseInitializeSystem P((int intype, int *num, int row, int col));
int       MouseInitialize P((int *));
void      MouseShow P((void));
void      MouseHide P((void));
void      MouseGetStatAndPos P((int *but, int *xpos, int *ypos));
void      MouseSetCursorPos P((int xpos, int ypos));
void      MouseSetHMinMax P((int xpos, int ypos));
void      MouseSetVMinMax P((int xpos, int ypos));
void      MouseSetTextCursor P((int cursor, int smaskval, int cmaskval));
int       MouseRestoreSystem P((void));
int       MouseGetStorageSize P((void));
void      MouseSaveState P((void *buf));
void      MouseRestoreState P((void *buf));
int       TranslateMousePress P((int press));
void      TranslateMousePosToScreenPos P((int ypos,int xpos,int *nypos,
                                         int *nxpos));
void      TranslateScreenPosToMousePos P((int ypos,int xpos,int *nypos,
                                          int *nxpos));
void      TranslateMousePosToWindowPos P((WPOINTER w, int ypos, int xpos,
                                          int *nypos, int *nxpos));
void      TranslateWindowPosToMousePos P((WPOINTER w, int ypos, int xpos,
                                          int *nypos, int *nxpos));

int       get_mouse_or_key P((int flag, int *which));
int       getmousekey P((int flag, int *which, int *hpos, int *vpos));

#ifdef __cplusplus
}
#endif
#endif

